/*
 * Copyright (c) 2020-2021, Bluetrum Development Team
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Change Logs:
 * Date           Author       Notes
 * 2020/12/10     greedyhao    The first version
 */

/**
 * Notice!
 * All functions or data that are called during an interrupt need to be in RAM.
 * You can do it the way exception_isr() does.
 */


#include <rtthread.h>
#include "board.h"
#include "stdio.h"
 uint8_t pin1,pin2,pin3,pin4,pin5,pin6,pin7,pin8,pin9,pin10,pin11;
#define spi_clk_1 rt_pin_write(pin1, PIN_HIGH)
#define spi_clk_0 rt_pin_write(pin1, PIN_LOW)
#define spi_cs_1 rt_pin_write(pin2, PIN_HIGH)
#define spi_cs_0 rt_pin_write(pin2, PIN_LOW)
#define spi_dout_1 rt_pin_write(pin3, PIN_HIGH)
#define spi_dout_0 rt_pin_write(pin3, PIN_LOW)

uint8_t scankeys(void);
void led_config(void);
void Write_Byte(uint8_t byte);
void display(void);
void f2c(double  k,uint8_t n);//doublefloat to char,for 8 numbers led max7219
double c2f(void);
char number1[9],p1,number2[9],p2,dis[9]={0x0f};
double  out_data=0,data1,data2;

int main(void)
{uint8_t key,z,i;
      pin1 = rt_pin_get("PE.5");//clk
      pin2 = rt_pin_get("PE.6");//cs
      pin3 = rt_pin_get("PE.7");//dout
rt_pin_mode(pin1,PIN_MODE_OUTPUT);
rt_pin_mode(pin2,PIN_MODE_OUTPUT);
rt_pin_mode(pin3,PIN_MODE_OUTPUT);
    rt_kprintf("Hello, world\n");
    led_config();
pin4 = rt_pin_get("PA.3");//pad1 1
pin5 = rt_pin_get("PA.4");//2
pin6 = rt_pin_get("PF.1");//3
pin7 = rt_pin_get("PB.0");//4
pin8 = rt_pin_get("PA.5");//pad2 4
pin9 = rt_pin_get("PE.1");//3
pin10 = rt_pin_get("PE.0");//2
pin11 = rt_pin_get("PF.0");//1

rt_pin_mode(pin4,PIN_MODE_INPUT);
rt_pin_mode(pin5,PIN_MODE_INPUT);
rt_pin_mode(pin6,PIN_MODE_INPUT);
rt_pin_mode(pin7,PIN_MODE_INPUT);
rt_pin_mode(pin8,PIN_MODE_INPUT);
rt_pin_mode(pin9,PIN_MODE_INPUT);
rt_pin_mode(pin10,PIN_MODE_INPUT);
rt_pin_mode(pin11,PIN_MODE_INPUT);

key=0;
p1=0;
p2=7;
while (1)
    {

        //rt_kprintf("%s\n",dis);

        //f2c(out_data,8);//float to char$

        //rt_kprintf("pin4\n");
        while(key==0)//no keys
        {
       key=scankeys();
        }
       rt_thread_mdelay(50);//delay 50ms,keys better
       key=scankeys();
       rt_kprintf("%x\n",key);

if(key!=0)//real keys
{
    switch (key)
    {
    case 0x80:  number1[p1]=0x01;//1
                if(p1<7){p1++;}
                break;
    case 0xc0:  number1[p1]=0x02;//2
                if(p1<7){p1++;}
                break;

    case 0x40:  number1[p1]=0x03;//3
                if(p1<7){p1++;}
                break;

    case 0x60:  number1[p1]=0x04;//4
                if(p1<7){p1++;}
                break;
    case 0x20:  number1[p1]=0x05;//5
                if(p1<7){p1++;}
                break;
    case 0x30:  z=4;
                data1=c2f();
                p1=0;
                p2=7;
                break;
    case 0x10:  p1=0;//clear
                p2=7;
                break;
    case 0x88:  number1[p1]=0x06;//6
                if(p1<7){p1++;}
                break;
    case 0x44:  number1[p1]=0x07;//7
                if(p1<7){p1++;}
                break;
    case 0x22:  number1[p1]=0x08;//8
                if(p1<7){p1++;}
                break;
    case 0x11:  //number1[p1-1]=number1[p1-1]|0x80;//.
                p2=p1-1;//小数点位置
                break;
    case 0x08:  number1[p1]=0x09;//9
                if(p1<7){p1++;}
                break;
    case 0x0c:  if ((number1[0]!=0)||p1==0||p2==0)
                {number1[p1]=0x00;//0
                }
                if(p1<7){p1++;}
                break;
    case 0x04:  z=1;//+
                data1=c2f();
                p1=0;
                p2=7;
                break;
    case 0x06:  z=2;//-
                data1=c2f();
                p1=0;
                p2=7;
                break;
    case 0x02:  z=3;//x
                data1=c2f();
                p1=0;
                p2=7;
                break;
    case 0x03:  data2=c2f();//result
                p1=0;
                p2=7;
                if(z==1){out_data=data1+data2;}
                else if(z==2){out_data=data1-data2;}
                else if(z==3){out_data=data1*data2;}
                else if(z==4){out_data=data1/data2;}
                break;
    case 0x01:      if(p1>0){p1--;}//back space
                    else{number1[p1]=0;}
                    break;

    }
    if(key==0x03)
    {
        f2c(out_data,8);
    }
    else{
        for(i=0;i<8;i++)
        {
        if(i<p1){dis[i]=number1[i];}
        else{dis[i]=0x0f;}
        }
        dis[p2]=dis[p2]|0x80;

    }
    display();
}

while (key&&scankeys()){}//no keys, go next
key=0;
    }
}

double c2f()
{double k=0;
long int base=10;
uint8_t i=0,j;
while(i<p1)
{
 if(i<=p2)
 {
     k=k*10+number1[i];//整数部分
 }
 else
 {
     k=k+number1[i]/base;//小数部分
     base=base*10;
 }
 i++;
}
return k;
}

void led_config(void)
{

// next for max7219
    rt_thread_mdelay(10);
spi_cs_1;
spi_cs_0;
Write_Byte(0x0c);//open
Write_Byte(0x01);
spi_cs_1;
spi_cs_0;
Write_Byte(0x09);//decode
Write_Byte(0xff);
spi_cs_1;
spi_cs_0;
Write_Byte(0x0b);//all 8 positions display on
Write_Byte(0x07);
spi_cs_1;
spi_cs_0;
//Write_Byte(0x0f);//all on for test
//Write_Byte(0x01);
//rt_kprintf("all display on for test\n");
//rt_thread_mdelay(2000);
spi_cs_0;
Write_Byte(0x0f);//all on mode off
Write_Byte(0x00);
//rt_kprintf("all display off for test\n");
/*
spi_cs_0;
Write_Byte(0x08);//num 8
Write_Byte(1);
spi_cs_1;
spi_cs_0;
Write_Byte(0x07);//num 7
Write_Byte(2);
spi_cs_1;
spi_cs_0;
Write_Byte(0x06);//num 6
Write_Byte(3);
spi_cs_1;
spi_cs_0;
Write_Byte(0x05);//num 5
Write_Byte(0x84);//MSB for point
spi_cs_1;
spi_cs_0;
Write_Byte(0x04);//num 4
Write_Byte(5);
spi_cs_1;
spi_cs_0;
Write_Byte(0x03);//num 3
Write_Byte(6);
spi_cs_1;
spi_cs_0;
Write_Byte(0x02);//num 2
Write_Byte(7);
spi_cs_1;
spi_cs_0;
Write_Byte(0x01);//num 1
Write_Byte(8);
spi_cs_1;
rt_kprintf("numbers on\n");
//rt_thread_mdelay(1000);
*/
}

uint8_t scankeys()
 {uint8_t k;
k= rt_pin_read(pin4)*0x80+rt_pin_read(pin5)*0x40+rt_pin_read(pin6)*0x20+rt_pin_read(pin7)*0x10
        +rt_pin_read(pin8)*0x08+rt_pin_read(pin9)*0x04+rt_pin_read(pin10)*0x02+rt_pin_read(pin11)*0x01;//read keys
return(k);
 }
void f2c(double  x,uint8_t n)//待完善：未做末尾四舍五入，
{uint8_t i,tempchar[20],j=0,k=0;
long int ipart,tempint;
double fpart;
for (i=0;i<=8;i++)//all blank
{
 dis[i]=0x0f;
}

if ((x>99999999)||(x<-9999999)){
        dis[7]=0x0b;
            }//exceed range,display 'E'
else {
    i=0;
    if(x<0){dis[i]=0x0a;i++;x=0-x;}//'-'
    ipart= (long int)(x);//inter part
    fpart=x-ipart;//dec part
    if(ipart==0){dis[i]=0x00;i++;}//0
    else{
        while(ipart!=0)
        {
            tempchar[j]=ipart%10;//
            ipart=ipart/10;
            j++;
        }
        k=0;
        while(k<j)
        {
            dis[i]=tempchar[j-k-1];
            i++;
            k++;
        }
    }
    if(fpart!=0){           //dec number
        if(i<n){dis[i-1]=dis[i-1]|0x80;}//小数点
        tempint=0;
        while(i<n)
            {
            fpart=fpart*10;
            tempint=(long int)fpart;
            dis[i]=(tempint%10);//只取个位
            i++;
            }
        i--;
        while(dis[i]==0){dis[i]=0x0f;i--;}//消除末尾多余的零
                }

    }
}

void display()
{
uint8_t k;

for(k=0;k<=8;k++)
        {
    spi_cs_0;
    Write_Byte(k);//num k
    Write_Byte(dis[8-k]);
    spi_cs_1;

        }
}


void Write_Byte(uint8_t byte){
    uint8_t i=0;
  for(i=0;i<8;i++){
    spi_clk_0;

    if(byte&0x80){//for max7219 MSB
      spi_dout_1;
    }else{
      spi_dout_0;
    }
    spi_clk_1;
    byte<<=1;//for max7219
    }
}

